"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Server_1 = require("../Server");
const services = require("../services");
const tmp = require("tmp");
const del = require("del");
const WebSocket = require("uws");
describe('LogService Integration Tests', function () {
    const PORT = 5678;
    const HOST = '127.0.0.1';
    let server;
    let tmpDir;
    let websocketClient;
    before(() => __awaiter(this, void 0, void 0, function* () {
        yield del(["./data"]);
        tmpDir = tmp.dirSync();
        Realm.clearTestState();
        server = new Server_1.Server({
            port: PORT,
            logLevel: 'off',
            dataPath: tmpDir.name
        });
        server.addService(new services.LogService());
        yield server.start();
    }));
    after(() => __awaiter(this, void 0, void 0, function* () {
        if (server) {
            yield server.shutdown();
        }
    }));
    afterEach(() => {
        if (websocketClient) {
            websocketClient.close();
            websocketClient = undefined;
        }
    });
    it('should be able to connect to a websocket', (done) => {
        websocketClient = new WebSocket(`ws://${HOST}:${PORT}/log/debug`);
        websocketClient.onopen = function (event) {
            done();
        };
        websocketClient.onerror = function (err) {
            done(err);
        };
    });
});
//# sourceMappingURL=logservice-integration-tests.spec.js.map