"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Server_1 = require("../Server");
const services = require("../services");
const del = require("del");
const tmp = require("tmp");
const path = require("path");
describe('User Metadata', function () {
    let tmpDir;
    let server;
    const HOST = '127.0.0.1';
    const PORT = 6789;
    let usernamePasswordAuthService;
    let adminUser;
    before(() => __awaiter(this, void 0, void 0, function* () {
        yield del(["./data"]);
        tmpDir = tmp.dirSync();
        Realm.clearTestState();
        server = new Server_1.Server({
            port: PORT,
            logLevel: 'off',
            dataPath: tmpDir.name
        });
        usernamePasswordAuthService = new services.UsernamePasswordAuthService({
            privateKeyPath: path.join(server.config.dataPath, "keys/auth.key"),
        });
        server.addService(usernamePasswordAuthService);
        server.addService(new services.RealmManagementService({
            privateKeyPath: path.join(server.config.dataPath, "keys/auth.key"),
        }));
        server.addService(new services.SyncProxyService());
        server.addService(new services.SyncService({
            dataPath: path.join(server.config.dataPath, "sync"),
            publicKeyPath: path.join(server.config.dataPath, "keys/auth.pub"),
        }));
        yield server.start();
        yield usernamePasswordAuthService.attemptToRegister('sally', 'ilovesushi', false);
        yield usernamePasswordAuthService.attemptToRegister('joe', 'ilovesushi', false);
    }));
});
//# sourceMappingURL=user-metadata-integration.spec.js.map