/// <reference types="node" />
import { Discovery } from '../discovery/Discovery';
import { AuthService, ResolvedUser } from './AuthService';
export declare const UsernamePasswordConstants: {
    saltWorkIterations: number;
    keyLength: number;
    saltLength: number;
    digest: string;
};
export declare class UsernamePasswordAuthService extends AuthService {
    private passwordRealm;
    discoveryReady(discovery: Discovery): Promise<void>;
    hashPassword(clearTextPassword: string, salt: Buffer): Promise<Buffer>;
    createSalt(saltWorkFactor: number): Promise<Buffer>;
    comparePassword(candidatePassword: string, salt: Buffer, hash: Buffer): Promise<boolean>;
    attemptToRegister(username: string, password: string, isAdmin?: boolean): Promise<ResolvedUser>;
    attemptToLogin(username: string, password: string): Promise<ResolvedUser>;
    authenticateOrCreateUser(body: any): Promise<ResolvedUser>;
}
